<?php

namespace Teknisa\DC\Controllers;

use Teknisa\DC\Util\Utilities;
use Zeedhi\Framework\Controller\Simple;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;

class Repository extends Simple {

    protected $repositoryService;

    public function __construct(\Teknisa\DC\Services\Repository $repositoryService) {
        $this->repositoryService = $repositoryService;
    }

    public function findResourceProjectRepositories(Request\Filter $request, Response $response){
        $conditions = $request->getFilterCriteria()->getConditions();
        $resource = $conditions[0]['value'];
        $project = $conditions[1]['value'] === 'null' ? null : $conditions[1]['value'];
        $repositories = $this->repositoryService->findResourceProjectRepositories($resource, $project);
        $response->addDataSet(new DataSet('resourceProjectRepositories', $repositories));
    }

    public function findRepositoriesWithFilter(Request\Filter $request, Response $response){
        $conditions = $request->getFilterCriteria()->getConditions();
        $repositories = $this->repositoryService->findRepositoriesWithFilter($conditions);
        $response->addDataSet(new DataSet('projectRepositories', $repositories));
    }
}