<?php

namespace Teknisa\DC\Factories;

use Zeedhi\DevOps\Util\Utilities;
use Zeedhi\DevOps\Model\Projectmanagement\Entities;

class Resource {
    public function createResource($externalId, $type, $isUser, $status, $email, $password, $name, $description, $class,
                                   $nickName, $documentNumber, $phone, $address, $district, $city, $zipCode, $parent,
                                   $availableFrom = null, $rating = 1){
        $entity = new Entities\Resource();
        $entity->setExternalId($externalId);
        $entity->setResourcesType($type);
        $entity->setStatus($status);
        $entity->setEmail($email);
        $entity->setPassword($password);
        $entity->setName($name);
        $entity->setDescription($description);
        $entity->setIsUser($isUser);
        $entity->setClass($class);
        $entity->setNickName($nickName);
        $entity->setDocumentNumber(Utilities::validateDocumentNumber($documentNumber));
        $entity->setPhone($phone);
        $entity->setAddress($address);
        $entity->setDistrict($district);
        $entity->setCity($city);
        $entity->setZipCode($zipCode);
        $entity->setParent($parent);
        $entity->setAvailableFrom($availableFrom);
        $entity->setRating($rating ? $rating : 1);
        return $entity;
    }

    public function updateResource( Entities\Resource $entity, $type, $isUser, $status, $email, $name, $description,
                                    $class, $nickName, $documentNumber, $phone, $address, $district, $city, $zipCode,
                                    $parent, $creator, $availableFrom = null, $rating = 1) {

        $entity->setResourcesType($type);
        $entity->setStatus($status);
        $entity->setEmail($email);
        $entity->setName($name);
        $entity->setDescription($description);
        $entity->setIsUser($isUser);
        $entity->setClass($class);
        $entity->setNickName($nickName);
        $entity->setDocumentNumber(Utilities::validateDocumentNumber($documentNumber));
        $entity->setPhone($phone);
        $entity->setAddress($address);
        $entity->setDistrict($district);
        $entity->setCity($city);
        $entity->setZipCode($zipCode);
        $entity->setParent($parent);
        $entity->setAvailableFrom($availableFrom);
        if(!empty($creator)){
            $entity->setCreatedBy($creator);
        }
        $entity->setRating($rating);
        return $entity;
    }

    public function updateResourceTypeUser(Entities\Resource $entity, $email, $password, $status, $name) {

        $entity->setStatus($status);
        $entity->setEmail($email);
        $entity->setPassword($password);
        $entity->setName($name);

        return $entity;
    }
} 