<?php
namespace Teknisa\DC\Services;

use Doctrine\ORM\EntityManager;

/**
 * Class Locale
 *
 * Service to provide data of countries, states and cities
 *
 * @package Service
 */
class Locale {

	/** @var EntityManager $entityManager */
	protected $entityManager;

	public function __construct(EntityManager $entityManager) {
		$this->entityManager = $entityManager;
	}

	public function getAllCountries() {
		/** @var \Zeedhi\DevOps\Model\Projectmanagement\Repositories\Country $countryRepository */
		$countryRepository = $this->entityManager->getRepository('\Zeedhi\DevOps\Model\Projectmanagement\Entities\Country');
		return $countryRepository->getCountries();
	}
	
	public function getCitiesByState($stateId) {
		/** @var \Zeedhi\DevOps\Model\Projectmanagement\Repositories\City $cityRepository */
		$cityRepository = $this->entityManager->getRepository('\Zeedhi\DevOps\Model\Projectmanagement\Entities\City');
		return $cityRepository->getCitiesByState($stateId);
	}
	
	public function getStatesByCountry($countryId) {
		/** @var \Zeedhi\DevOps\Model\Projectmanagement\Repositories\State $stateRepository */
		$stateRepository = $this->entityManager->getRepository('\Zeedhi\DevOps\Model\Projectmanagement\Entities\State');
		return $stateRepository->getStatesByCountry($countryId);
	}


} 