<?php

namespace Teknisa\DC\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\DC\Util\Messages;
use Teknisa\DC\Util\Utilities;
use Teknisa\DC\Factories;
use Zeedhi\Framework\Controller\Exception;
use Zeedhi\Framework\HTTP\Kernel;
use Zeedhi\DevOps\Model\Projectmanagement\Entities;

class Repository
{

    protected $entityManager;
    protected $environment;
    /** @var \Zeedhi\DevOps\Model\Projectmanagement\Repositories\Repository */
    protected $repositoryRepository;

    public function __construct(EntityManager $entityManager, Utilities $environment)
    {
        $this->entityManager = $entityManager;
        $this->environment   = $environment;

        $this->repositoryRepository = $this->entityManager->getRepository(Utilities::ENTITY_DIR . 'Repository');
    }

    public function findResourceProjectRepositories($resource, $project) {
        if ($resource == 0) {
            $resource = $this->environment->getCurrentUserId();
        }
        return $Repository = $this->repositoryRepository->findRepositoriesByResource($resource, $project);
    }

    public function findRepositoriesWithFilter($conditions){
        $filter = Utilities::createQueryFiltered($conditions, 'R');
        $repositories = $this->repositoryRepository->findRepositoriesWithFilter($filter);
        return $repositories;
    }
}