<?php

namespace Teknisa\DC\Services;

use Teknisa\DC\Util\Utilities;
use Doctrine\ORM\EntityManager;
use Zeedhi\DevOps\Model\Projectmanagement\Repositories;

class Task {
    protected $utilities;
    protected $entityManager;
    /** @var Repositories\Task $taskRepository */
    protected $taskRepository;

    public function __construct(EntityManager $entityManager, Utilities $utilities) {
        $this->entityManager  = $entityManager;
        $this->utilities      = $utilities;
        $this->taskRepository = $this->entityManager->getRepository(Utilities::ENTITY_DIR . 'Task');
    }

    public function getProjectTasksInitialized($projectId){
        $user      = $this->utilities->getCurrentUserId();
        $projectId = preg_replace("/[^0-9]/", "", $projectId);
        return $this->taskRepository->getProjectTasksInitialized($user, $projectId);
    }
} 